Package org.apache.sis.metadata.iso.citation

## Class DefaultCitationDate

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultCitationDate

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `CitationDate`

      @TitleProperty(name="date")
      public class DefaultCitationDate
      extends ISOMetadata
      implements CitationDate

  Reference date and event used to describe it. The following properties are mandatory in a well-formed metadata according ISO 19115:
  `CI_Date` `├─date………………` Reference date for the cited resource. `└─dateType……` Event used for reference date.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultCitationDate()` | Constructs an initially empty citation date.
    `DefaultCitationDate​(Date date, DateType dateType)` | Constructs a citation date initialized to the given date.
    `DefaultCitationDate​(CitationDate object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultCitationDate` | `castOrCopy​(CitationDate object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Date` | `getDate()` | Returns the reference date for the cited resource.
    `DateType` | `getDateType()` | Returns the event used for reference date.
    `void` | `setDate​(Date newValue)` | Sets the reference date for the cited resource.
    `void` | `setDateType​(DateType newValue)` | Sets the event used for reference date.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultCitationDate

          public DefaultCitationDate()

      Constructs an initially empty citation date.

    - #### DefaultCitationDate

          public DefaultCitationDate​(Date date,
                                     DateType dateType)

      Constructs a citation date initialized to the given date.
      Parameters:
        `date` - the reference date for the cited resource.
        `dateType` - the event used for reference date.

    - #### DefaultCitationDate

          public DefaultCitationDate​(CitationDate object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(CitationDate)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultCitationDate castOrCopy​(CitationDate object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultCitationDate`, then it is returned unchanged.
      - Otherwise a new `DefaultCitationDate` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getDate

          public Date getDate()

      Returns the reference date for the cited resource.
      Specified by:
        `getDate` in interface `CitationDate`
      Returns:
        reference date for the cited resource, or `null`.

    - #### setDate

          public void setDate​(Date newValue)

      Sets the reference date for the cited resource.
      Parameters:
        `newValue` - the new date.

    - #### getDateType

          public DateType getDateType()

      Returns the event used for reference date.
      Specified by:
        `getDateType` in interface `CitationDate`
      Returns:
        event used for reference date, or `null`.

    - #### setDateType

          public void setDateType​(DateType newValue)

      Sets the event used for reference date.
      Parameters:
        `newValue` - the new event.